gtkmm 2.4: Gdk::Pixbuf Class Reference

Main Page Widgets Namespaces Book

# Gdk::Pixbuf Class Reference

Inheritance diagram for Gdk::Pixbuf:
[legend]
List of all members.

## Public Types
typedef Glib::SListHandle< Glib::RefPtr<PixbufFormat>, PixbufFormatTraits > | SListHandle_PixbufFormat
typedef sigc::slot< void, const guint8* > | SlotDestroyData
## Public Member Functions
Glib::RefPtr<Gdk::Pixbuf> | add_alpha (bool substitute_color, guint8 r, guint8 g, guint8 b) const
| Takes an existing pixbuf and adds an alpha channel to it.
void | composite (const Glib::RefPtr<Gdk::Pixbuf>& dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, InterpType interp_type, int overall_alpha) const
| Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y .
void | composite_color (const Glib::RefPtr<Gdk::Pixbuf>& dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, InterpType interp_type, int overall_alpha, int check_x, int check_y, int check_size, guint32 color1, guint32 color2) const
| Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y , then composites the rectangle ( dest_x , dest_y , dest_width , dest_height ) of the resulting image with a checkboard of the colors color1 and color2 and renders it onto the destination image.
Glib::RefPtr<Gdk::Pixbuf> | composite_color_simple (int dest_width, int dest_height, InterpType interp_type, int overall_alpha, int check_size, guint32 color1, guint32 color2) const
| Creates a new Gdk::Pixbuf by scaling src to dest_width x dest_height and compositing the result with a checkboard of colors color1 and color2 .
Glib::RefPtr<Pixbuf> | copy () const
| Creates a new Gdk::Pixbuf with a copy of the information in the specified pixbuf .
void | copy_area (int src_x, int src_y, int width, int height, const Glib::RefPtr<Gdk::Pixbuf>& dest_pixbuf, int dest_x, int dest_y) const
| Copies a rectangular area from src_pixbuf to dest_pixbuf .
void | fill (guint32 pixel)
| Clears a pixbuf to the given RGBA value, converting the RGBA value into the pixbuf's pixel format.
Glib::RefPtr<Gdk::Pixbuf> | flip (bool horizontal=true) const
| Flips a pixbuf horizontally or vertically and returns the result in a new pixbuf.
int | get_bits_per_sample () const
| Queries the number of bits per color sample in a pixbuf.
Colorspace | get_colorspace () const
| Queries the color space of a pixbuf.
bool | get_has_alpha () const
| Queries whether a pixbuf has an alpha channel (opacity information).
int | get_height () const
| Queries the height of a pixbuf.
int | get_n_channels () const
| Queries the number of channels of a pixbuf.
Glib::ustring | get_option (const Glib::ustring& key) const
| Looks up key in the list of options that may have been attached to the pixbuf when it was loaded.
guint8* | get_pixels () const
| Queries a pointer to the pixel data of a pixbuf.
int | get_rowstride () const
| Queries the rowstride of a pixbuf, which is the number of bytes between the start of a row and the start of the next row.
int | get_width () const
| Queries the width of a pixbuf.
const GdkPixbuf* | gobj () const
| Provides access to the underlying C GObject.
GdkPixbuf* | gobj ()
| Provides access to the underlying C GObject.
GdkPixbuf* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | render_pixmap_and_mask (Glib::RefPtr<Pixmap>& pixmap_return, Glib::RefPtr<Bitmap>& mask_return, int alpha_threshold)
void | render_pixmap_and_mask_for_colormap (const Glib::RefPtr<Colormap>& colormap, Glib::RefPtr<Pixmap>& pixmap_return, Glib::RefPtr<Bitmap>& mask_return, int alpha_threshold)
void | render_threshold_alpha (const Glib::RefPtr<Gdk::Bitmap>& bitmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height, int alpha_threshold)
| Takes the opacity values in a rectangular portion of a pixbuf and thresholds them to produce a bi-level alpha mask that can be used as a clipping mask for a drawable.
void | render_to_drawable (const Glib::RefPtr<Drawable>& drawable, const Glib::RefPtr<Gdk::GC>& gc, int src_x, int src_y, int dest_x, int dest_y, int width, int height, RgbDither dither, int x_dither, int y_dither)
| Renders a rectangular portion of a pixbuf to a drawable while using the specified GC.
void | render_to_drawable_alpha (const Glib::RefPtr<Drawable>& drawable, int src_x, int src_y, int dest_x, int dest_y, int width, int height, PixbufAlphaMode alpha_mode, int alpha_threshold, RgbDither dither, int x_dither, int y_dither)
| Renders a rectangular portion of a pixbuf to a drawable.
Glib::RefPtr<Gdk::Pixbuf> | rotate_simple (PixbufRotation angle) const
| Rotates a pixbuf by a multiple of 90 degrees, and returns the result in a new pixbuf.
void | saturate_and_pixelate (const Glib::RefPtr<Gdk::Pixbuf>& dest, float saturation, bool pixelate) const
| Modifies saturation and optionally pixelates src , placing the result in dest .
void | save (const std::string& filename, const Glib::ustring&type, const Glib::StringArrayHandle& option_keys, const Glib::StringArrayHandle& option_values)
| Save an image file.
void | save (const std::string& filename, const Glib::ustring&type)
| Save an image file.
void | save_to_buffer (gchar*& buffer, gsize& buffer_size, const Glib::ustring&type, const Glib::StringArrayHandle& option_keys, const Glib::StringArrayHandle& option_values)
void | scale (const Glib::RefPtr<Gdk::Pixbuf>& dest, int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, InterpType interp_type) const
| Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y , then renders the rectangle ( dest_x , dest_y , dest_width , dest_height ) of the resulting image onto the destination image replacing the previous contents.
Glib::RefPtr<Gdk::Pixbuf> | scale_simple (int dest_width, int dest_height, InterpType interp_type) const
| Create a new Gdk::Pixbuf containing a copy of src scaled to dest_width x dest_height .
virtual | ~Pixbuf ()
## Static Public Member Functions
Glib::RefPtr<Pixbuf> | create (Colorspace colorspace, bool has_alpha, int bits_per_sample, int width, int height)
| Creates a new Gdk::Pixbuf structure and allocates a buffer for it.
Glib::RefPtr<Pixbuf> | create (const Glib::RefPtr<Image>& src, const Glib::RefPtr<Colormap>& cmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height)
Glib::RefPtr<Pixbuf> | create (const Glib::RefPtr<Drawable>& src, const Glib::RefPtr<Colormap>& cmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height)
Glib::RefPtr<Pixbuf> | create_from_data (const guint8* data, Colorspace colorspace, bool has_alpha, int bits_per_sample, int width, int height, int rowstride, const SlotDestroyData& destroy_slot)
| Creates a new Gdk::Pixbuf out of in-memory image data.
Glib::RefPtr<Pixbuf> | create_from_data (const guint8* data, Colorspace colorspace, bool has_alpha, int bits_per_sample, int width, int height, int rowstride)
| Creates a new Gdk::Pixbuf out of in-memory image data.
Glib::RefPtr<Pixbuf> | create_from_file (const std::string& filename, int width, int height, bool preserve_aspect_ratio=true)
| Creates a new pixbuf by loading an image from a file.
Glib::RefPtr<Pixbuf> | create_from_file (const std::string& filename)
| Creates a new pixbuf by loading an image from a file.
Glib::RefPtr<Pixbuf> | create_from_inline (int data_length, const guint8* data, bool copy_pixels=false)
| Create a Gdk::Pixbuf from a flat representation that is suitable for storing as inline data in a program.
Glib::RefPtr<Pixbuf> | create_from_xpm_data (const char* const* data)
| Creates a new pixbuf by parsing XPM data in memory.
Glib::RefPtr<Pixbuf> | create_subpixbuf (const Glib::RefPtr<Pixbuf>& src_pixbuf, int src_x, int src_y, int width, int height)
| Creates a new pixbuf which represents a sub-region of src_pixbuf .
SListHandle_PixbufFormat | get_formats ()
## Protected Member Functions
| Pixbuf (const Glib::RefPtr<Image>& src, const Glib::RefPtr<Colormap>& cmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height)
| Pixbuf (const Glib::RefPtr<Drawable>& src, const Glib::RefPtr<Colormap>& cmap, int src_x, int src_y, int dest_x, int dest_y, int width, int height)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr<Gdk::Pixbuf> | wrap (GdkPixbuf* object, bool take_copy=false)

## Member Typedef Documentation

typedef Glib::SListHandle<Glib::RefPtr<PixbufFormat>, PixbufFormatTraits> Gdk::Pixbuf::SListHandle_PixbufFormat

typedef sigc::slot<void, const guint8*> Gdk::Pixbuf::SlotDestroyData

## Constructor & Destructor Documentation

virtual Gdk::Pixbuf::~Pixbuf | ( |  | ) | `[virtual]`

Gdk::Pixbuf::Pixbuf | ( | const Glib::RefPtr<Drawable>& | src,
|  | const Glib::RefPtr<Colormap>& | cmap,
|  | int | src_x,
|  | int | src_y,
|  | int | dest_x,
|  | int | dest_y,
|  | int | width,
|  | int | height
| ) | `[protected]`

Gdk::Pixbuf::Pixbuf | ( | const Glib::RefPtr<Image>& | src,
|  | const Glib::RefPtr<Colormap>& | cmap,
|  | int | src_x,
|  | int | src_y,
|  | int | dest_x,
|  | int | dest_y,
|  | int | width,
|  | int | height
| ) | `[protected]`

## Member Function Documentation

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::add_alpha | ( | bool | substitute_color,
|  | guint8 | r,
|  | guint8 | g,
|  | guint8 | b
| ) | const

  | Takes an existing pixbuf and adds an alpha channel to it. If the existing pixbuf already had an alpha channel, the channel values are copied from the original; otherwise, the alpha channel is initialized to 255 (full opacity). If substitute_color is `true`, then the color specified by ( r , g , b ) will be assigned zero opacity. That is, if you pass (255, 255, 255) for the substitute color, all white pixels will become fully transparent. Parameters:
  | substitute_color | Whether to set a color to zero opacity. If this is `false`, then the ( r , g , b ) arguments will be ignored.
  | r | Red value to substitute.
  | g | Green value to substitute.
  | b | Blue value to substitute.
Returns: A newly-created pixbuf with a reference count of 1.

void Gdk::Pixbuf::composite | ( | const Glib::RefPtr<Gdk::Pixbuf>& | dest,
|  | int | dest_x,
|  | int | dest_y,
|  | int | dest_width,
|  | int | dest_height,
|  | double | offset_x,
|  | double | offset_y,
|  | double | scale_x,
|  | double | scale_y,
|  | InterpType | interp_type,
|  | int | overall_alpha
| ) | const

  | Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y . This gives an image in the coordinates of the destination pixbuf. The rectangle ( dest_x , dest_y , dest_width , dest_height ) is then composited onto the corresponding rectangle of the original destination image. When the destination rectangle contains parts not in the source image, the data at the edges of the source image is replicated to infinity. <figure id="pixbuf-composite-diagram"> <title>Compositing of pixbufs</title> <graphic fileref="composite.png" format="PNG"/> </figure> Parameters:
  | dest | The Gdk::Pixbuf into which to render the results.
  | dest_x | The left coordinate for region to render.
  | dest_y | The top coordinate for region to render.
  | dest_width | The width of the region to render.
  | dest_height | The height of the region to render.
  | offset_x | The offset in the X direction (currently rounded to an integer).
  | offset_y | The offset in the Y direction (currently rounded to an integer).
  | scale_x | The scale factor in the X direction.
  | scale_y | The scale factor in the Y direction.
  | interp_type | The interpolation type for the transformation.
  | overall_alpha | Overall alpha for source image (0..255).

void Gdk::Pixbuf::composite_color | ( | const Glib::RefPtr<Gdk::Pixbuf>& | dest,
|  | int | dest_x,
|  | int | dest_y,
|  | int | dest_width,
|  | int | dest_height,
|  | double | offset_x,
|  | double | offset_y,
|  | double | scale_x,
|  | double | scale_y,
|  | InterpType | interp_type,
|  | int | overall_alpha,
|  | int | check_x,
|  | int | check_y,
|  | int | check_size,
|  | guint32 | color1,
|  | guint32 | color2
| ) | const

  | Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y , then composites the rectangle ( dest_x , dest_y , dest_width , dest_height ) of the resulting image with a checkboard of the colors color1 and color2 and renders it onto the destination image. See composite_color_simple() for a simpler variant of this function suitable for many tasks. Parameters:
  | dest | The Gdk::Pixbuf into which to render the results.
  | dest_x | The left coordinate for region to render.
  | dest_y | The top coordinate for region to render.
  | dest_width | The width of the region to render.
  | dest_height | The height of the region to render.
  | offset_x | The offset in the X direction (currently rounded to an integer).
  | offset_y | The offset in the Y direction (currently rounded to an integer).
  | scale_x | The scale factor in the X direction.
  | scale_y | The scale factor in the Y direction.
  | interp_type | The interpolation type for the transformation.
  | overall_alpha | Overall alpha for source image (0..255).
  | check_x | The X offset for the checkboard (origin of checkboard is at - check_x , - check_y ).
  | check_y | The Y offset for the checkboard.
  | check_size | The size of checks in the checkboard (must be a power of two).
  | color1 | The color of check at upper left.
  | color2 | The color of the other check.

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::composite_color_simple | ( | int | dest_width,
|  | int | dest_height,
|  | InterpType | interp_type,
|  | int | overall_alpha,
|  | int | check_size,
|  | guint32 | color1,
|  | guint32 | color2
| ) | const

  | Creates a new Gdk::Pixbuf by scaling src to dest_width x dest_height and compositing the result with a checkboard of colors color1 and color2 . Parameters:
  | dest_width | The width of destination image.
  | dest_height | The height of destination image.
  | interp_type | The interpolation type for the transformation.
  | overall_alpha | Overall alpha for source image (0..255).
  | check_size | The size of checks in the checkboard (must be a power of two).
  | color1 | The color of check at upper left.
  | color2 | The color of the other check.
Returns: The new Gdk::Pixbuf, or `0` if not enough memory could be allocated for it.

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::copy | ( |  | ) | const

| Creates a new Gdk::Pixbuf with a copy of the information in the specified pixbuf . Returns: A newly-created pixbuf with a reference count of 1, or `0` if not enough memory could be allocated.

void Gdk::Pixbuf::copy_area | ( | int | src_x,
|  | int | src_y,
|  | int | width,
|  | int | height,
|  | const Glib::RefPtr<Gdk::Pixbuf>& | dest_pixbuf,
|  | int | dest_x,
|  | int | dest_y
| ) | const

  | Copies a rectangular area from src_pixbuf to dest_pixbuf . Conversion of pixbuf formats is done automatically. Parameters:
  | src_x | Source X coordinate within src_pixbuf .
  | src_y | Source Y coordinate within src_pixbuf .
  | width | Width of the area to copy.
  | height | Height of the area to copy.
  | dest_pixbuf | Destination pixbuf.
  | dest_x | X coordinate within dest_pixbuf .
  | dest_y | Y coordinate within dest_pixbuf .

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create | ( | Colorspace | colorspace,
|  | bool | has_alpha,
|  | int | bits_per_sample,
|  | int | width,
|  | int | height
| ) | `[static]`

  | Creates a new Gdk::Pixbuf structure and allocates a buffer for it. The buffer has an optimal rowstride. Note that the buffer is not cleared; you will have to fill it completely yourself. Parameters:
  | colorspace | Color space for image.
  | has_alpha | Whether the image should have transparency information.
  | bits_per_sample | Number of bits per color sample.
  | width | Width of image in pixels.
  | height | Height of image in pixels.
Returns: A newly-created Gdk::Pixbuf with a reference count of 1, or `0` if not enough memory could be allocated for the image buffer.

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create | ( | const Glib::RefPtr<Image>& | src,
|  | const Glib::RefPtr<Colormap>& | cmap,
|  | int | src_x,
|  | int | src_y,
|  | int | dest_x,
|  | int | dest_y,
|  | int | width,
|  | int | height
| ) | `[static]`

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create | ( | const Glib::RefPtr<Drawable>& | src,
|  | const Glib::RefPtr<Colormap>& | cmap,
|  | int | src_x,
|  | int | src_y,
|  | int | dest_x,
|  | int | dest_y,
|  | int | width,
|  | int | height
| ) | `[static]`

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_data | ( | const guint8* | data,
|  | Colorspace | colorspace,
|  | bool | has_alpha,
|  | int | bits_per_sample,
|  | int | width,
|  | int | height,
|  | int | rowstride,
|  | const SlotDestroyData& | destroy_slot
| ) | `[static]`

  | Creates a new Gdk::Pixbuf out of in-memory image data. Currently only RGB images with 8 bits per sample are supported. Parameters:
  | data | Image data in 8-bit/sample packed format.
  | colorspace | Colorspace for the image data.
  | has_alpha | Whether the data has an opacity channel.
  | bits_per_sample | Number of bits per sample.
  | width | Width of the image in pixels.
  | height | Height of the image in pixels.
  | rowstride | Distance in bytes between rows.
  | destroy_slot | Slot used to free the data when the pixbuf's reference count drops to zero.
Returns: A newly-created Gdk::Pixbuf object.

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_data | ( | const guint8* | data,
|  | Colorspace | colorspace,
|  | bool | has_alpha,
|  | int | bits_per_sample,
|  | int | width,
|  | int | height,
|  | int | rowstride
| ) | `[static]`

  | Creates a new Gdk::Pixbuf out of in-memory image data. Currently only RGB images with 8 bits per sample are supported. Parameters:
  | data | Image data in 8-bit/sample packed format.
  | colorspace | Colorspace for the image data.
  | has_alpha | Whether the data has an opacity channel.
  | bits_per_sample | Number of bits per sample.
  | width | Width of the image in pixels.
  | height | Height of the image in pixels.
  | rowstride | Distance in bytes between rows.
Returns: A newly-created Gdk::Pixbuf object.

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_file | ( | const std::string& | filename,
|  | int | width,
|  | int | height,
|  | bool | preserve_aspect_ratio = `true`
| ) | `[static]`

  | Creates a new pixbuf by loading an image from a file. The file format is detected automatically. The image will be scaled to fit in the requested size. Parameters:
  | filename | The path to the pixbuf file.
  | width | The desired width
  | height | The desired height
  | preserve_aspect_ratio: | Whether the image's aspect ratio will be preserved when scaling.
  Exceptions:
  | Glib::FileError |
  | Gdk::PixbufError |

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_file | ( | const std::string& | filename | ) | `[static]`

  | Creates a new pixbuf by loading an image from a file. The file format is detected automatically. Parameters:
  | filename | The path to the pixbuf file.
  Exceptions:
  | Glib::FileError |
  | Gdk::PixbufError |

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_inline | ( | int | data_length,
|  | const guint8* | data,
|  | bool | copy_pixels = `false`
| ) | `[static]`

  | Create a Gdk::Pixbuf from a flat representation that is suitable for storing as inline data in a program. This is useful if you want to ship a program with images, but don't want to depend on any external files. GTK+ ships with a program called `gdk-pixbuf-csource` which allows for conversion of GdkPixbufs into such a inline representation. In almost all cases, you should pass the `--raw` flag to `gdk-pixbuf-csource`. A sample invocation would be: `gdk-pixbuf-csource --raw --name=myimage_inline myimage.png` For the typical case where the inline pixbuf is read-only static data, you don't need to copy the pixel data unless you intend to write to it, so you can pass `false` for copy_pixels. (If you pass `--rle` to `gdk-pixbuf-csource`, a copy will be made even if copy_pixels is `false`, so using this option is generally a bad idea.) If you create a pixbuf from const inline data compiled into your program, it's probably safe to ignore errors, since things will always succeed. For non-const inline data, you could get out of memory. For untrusted inline data located at runtime, you could have corrupt inline data in addition. Parameters:
  | data_length | Length in bytes of the data argument.
  | data | Byte data containing a serialized GdkPixdata structure.
  | copy_pixels | Whether to copy the pixel data, or use direct pointers to data for the resulting pixbuf.
  Exceptions:
  | Gdk::PixbufError |

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_from_xpm_data | ( | const char *const* | data | ) | `[static]`

  | Creates a new pixbuf by parsing XPM data in memory. This data is commonly the result of including an XPM file into a program's C source. Parameters:
  | data | Pointer to inline XPM data.
Returns: A newly-created pixbuf with a reference count of 1.

Glib::RefPtr<Pixbuf> Gdk::Pixbuf::create_subpixbuf | ( | const Glib::RefPtr<Pixbuf>& | src_pixbuf,
|  | int | src_x,
|  | int | src_y,
|  | int | width,
|  | int | height
| ) | `[static]`

  | Creates a new pixbuf which represents a sub-region of src_pixbuf . The new pixbuf shares its pixels with the original pixbuf, so writing to one affects both. The new pixbuf holds a reference to src_pixbuf , so src_pixbuf will not be finalized until the new pixbuf is finalized. Parameters:
  | src_pixbuf | A Gdk::Pixbuf.
  | src_x | X coord in src_pixbuf .
  | src_y | Y coord in src_pixbuf .
  | width | Width of region in src_pixbuf .
  | height | Height of region in src_pixbuf .
Returns: A new pixbuf.

void Gdk::Pixbuf::fill | ( | guint32 | pixel | ) |

  | Clears a pixbuf to the given RGBA value, converting the RGBA value into the pixbuf's pixel format. The alpha will be ignored if the pixbuf doesn't have an alpha channel. Parameters:
  | pixel | RGBA pixel to clear to (0xffffffff is opaque white, 0x00000000 transparent black).

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::flip | ( | bool | horizontal = `true` | ) | const

  | Flips a pixbuf horizontally or vertically and returns the result in a new pixbuf. Parameters:
  | horizontal | `true` to flip horizontally, `false` to flip vertically.
Returns: A new pixbuf. Since: 2.6.

int Gdk::Pixbuf::get_bits_per_sample | ( |  | ) | const

| Queries the number of bits per color sample in a pixbuf. Returns: Number of bits per color sample.

Colorspace Gdk::Pixbuf::get_colorspace | ( |  | ) | const

| Queries the color space of a pixbuf. Returns: Color space.

SListHandle_PixbufFormat Gdk::Pixbuf::get_formats | ( |  | ) | `[static]`

bool Gdk::Pixbuf::get_has_alpha | ( |  | ) | const

| Queries whether a pixbuf has an alpha channel (opacity information). Returns: `true` if it has an alpha channel, `false` otherwise.

int Gdk::Pixbuf::get_height | ( |  | ) | const

| Queries the height of a pixbuf. Returns: Height in pixels.

int Gdk::Pixbuf::get_n_channels | ( |  | ) | const

| Queries the number of channels of a pixbuf. Returns: Number of channels.

Glib::ustring Gdk::Pixbuf::get_option | ( | const Glib::ustring& | key | ) | const

  | Looks up key in the list of options that may have been attached to the pixbuf when it was loaded. Parameters:
  | key | A nul-terminated string.
Returns: The value associated with key . This is a nul-terminated string that should not be freed or `0` if key was not found.

guint8* Gdk::Pixbuf::get_pixels | ( |  | ) | const

| Queries a pointer to the pixel data of a pixbuf. Returns: A pointer to the pixbuf's pixel data. Please see <xref linkend="image-data"/> for information about how the pixel data is stored in memory.

int Gdk::Pixbuf::get_rowstride | ( |  | ) | const

| Queries the rowstride of a pixbuf, which is the number of bytes between the start of a row and the start of the next row. Returns: Distance between row starts.

int Gdk::Pixbuf::get_width | ( |  | ) | const

| Queries the width of a pixbuf. Returns: Width in pixels.

const GdkPixbuf* Gdk::Pixbuf::gobj | ( |  | ) | const`[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::ObjectBase.

GdkPixbuf* Gdk::Pixbuf::gobj | ( |  | ) | `[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::ObjectBase.

GdkPixbuf* Gdk::Pixbuf::gobj_copy | ( |  | ) |

| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gdk::Pixbuf::render_pixmap_and_mask | ( | Glib::RefPtr<Pixmap>& | pixmap_return,
|  | Glib::RefPtr<Bitmap>& | mask_return,
|  | int | alpha_threshold
| ) |

void Gdk::Pixbuf::render_pixmap_and_mask_for_colormap | ( | const Glib::RefPtr<Colormap>& | colormap,
|  | Glib::RefPtr<Pixmap>& | pixmap_return,
|  | Glib::RefPtr<Bitmap>& | mask_return,
|  | int | alpha_threshold
| ) |

void Gdk::Pixbuf::render_threshold_alpha | ( | const Glib::RefPtr<Gdk::Bitmap>& | bitmap,
|  | int | src_x,
|  | int | src_y,
|  | int | dest_x,
|  | int | dest_y,
|  | int | width,
|  | int | height,
|  | int | alpha_threshold
| ) |

  | Takes the opacity values in a rectangular portion of a pixbuf and thresholds them to produce a bi-level alpha mask that can be used as a clipping mask for a drawable. Parameters:
  | bitmap | Bitmap where the bilevel mask will be painted to.
  | src_x | Source X coordinate.
  | src_y | Source Y coordinate.
  | dest_x | Destination X coordinate.
  | dest_y | Destination Y coordinate.
  | width | Width of region to threshold, or -1 to use pixbuf width.
  | height | Height of region to threshold, or -1 to use pixbuf height.
  | alpha_threshold | Opacity values below this will be painted as zero; all other values will be painted as one.

void Gdk::Pixbuf::render_to_drawable | ( | const Glib::RefPtr<Drawable>& | drawable,
|  | const Glib::RefPtr<Gdk::GC>& | gc,
|  | int | src_x,
|  | int | src_y,
|  | int | dest_x,
|  | int | dest_y,
|  | int | width,
|  | int | height,
|  | RgbDither | dither,
|  | int | x_dither,
|  | int | y_dither
| ) |

  | Renders a rectangular portion of a pixbuf to a drawable while using the specified GC. This is done using GdkRGB, so the specified drawable must have the GdkRGB visual and colormap. Note that this function will ignore the opacity information for images with an alpha channel; the GC must already have the clipping mask set if you want transparent regions to show through. For an explanation of dither offsets, see the GdkRGB documentation. In brief, the dither offset is important when re-rendering partial regions of an image to a rendered version of the full image, or for when the offsets to a base position change, as in scrolling. The dither matrix has to be shifted for consistent visual results. If you do not have any of these cases, the dither offsets can be both zero. Deprecated: This function is obsolete. Use gdk_draw_pixbuf() instead. Parameters:
  | drawable | Destination drawable.
  | gc | GC used for rendering.
  | src_x | Source X coordinate within pixbuf.
  | src_y | Source Y coordinate within pixbuf.
  | dest_x | Destination X coordinate within drawable.
  | dest_y | Destination Y coordinate within drawable.
  | width | Width of region to render, in pixels, or -1 to use pixbuf width.
  | height | Height of region to render, in pixels, or -1 to use pixbuf height.
  | dither | Dithering mode for GdkRGB.
  | x_dither | X offset for dither.
  | y_dither | Y offset for dither.

void Gdk::Pixbuf::render_to_drawable_alpha | ( | const Glib::RefPtr<Drawable>& | drawable,
|  | int | src_x,
|  | int | src_y,
|  | int | dest_x,
|  | int | dest_y,
|  | int | width,
|  | int | height,
|  | PixbufAlphaMode | alpha_mode,
|  | int | alpha_threshold,
|  | RgbDither | dither,
|  | int | x_dither,
|  | int | y_dither
| ) |

  | Renders a rectangular portion of a pixbuf to a drawable. The destination drawable must have a colormap. All windows have a colormap, however, pixmaps only have colormap by default if they were created with a non-`0` window argument. Otherwise a colormap must be set on them with gdk_drawable_set_colormap. On older X servers, rendering pixbufs with an alpha channel involves round trips to the X server, and may be somewhat slow. Deprecated: This function is obsolete. Use gdk_draw_pixbuf() instead. Parameters:
  | drawable | Destination drawable.
  | src_x | Source X coordinate within pixbuf.
  | src_y | Source Y coordinates within pixbuf.
  | dest_x | Destination X coordinate within drawable.
  | dest_y | Destination Y coordinate within drawable.
  | width | Width of region to render, in pixels, or -1 to use pixbuf width.
  | height | Height of region to render, in pixels, or -1 to use pixbuf height.
  | alpha_mode | Ignored. Present for backwards compatibility.
  | alpha_threshold | Ignored. Present for backwards compatibility.
  | dither | Dithering mode for GdkRGB.
  | x_dither | X offset for dither.
  | y_dither | Y offset for dither.

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::rotate_simple | ( | PixbufRotation | angle | ) | const

  | Rotates a pixbuf by a multiple of 90 degrees, and returns the result in a new pixbuf. Parameters:
  | angle | The angle to rotate by.
Returns: A new pixbuf Since: 2.6.

void Gdk::Pixbuf::saturate_and_pixelate | ( | const Glib::RefPtr<Gdk::Pixbuf>& | dest,
|  | float | saturation,
|  | bool | pixelate
| ) | const

  | Modifies saturation and optionally pixelates src , placing the result in dest . src and dest may be the same pixbuf with no ill effects. If saturation is 1.0 then saturation is not changed. If it's less than 1.0, saturation is reduced (the image is darkened); if greater than 1.0, saturation is increased (the image is brightened). If pixelate is `true`, then pixels are faded in a checkerboard pattern to create a pixelated image. src and dest must have the same image format, size, and rowstride. Parameters:
  | dest | Place to write modified version of src .
  | saturation | Saturation factor.
  | pixelate | Whether to pixelate.

void Gdk::Pixbuf::save | ( | const std::string& | filename,
|  | const Glib::ustring& | type,
|  | const Glib::StringArrayHandle& | option_keys,
|  | const Glib::StringArrayHandle& | option_values
| ) |

  | Save an image file. Exceptions:
  | Glib::FileError |
  | Gdk::PixbufError |

void Gdk::Pixbuf::save | ( | const std::string& | filename,
|  | const Glib::ustring& | type
| ) |

  | Save an image file. Exceptions:
  | Glib::FileError |
  | Gdk::PixbufError |

void Gdk::Pixbuf::save_to_buffer | ( | gchar *& | buffer,
|  | gsize& | buffer_size,
|  | const Glib::ustring& | type,
|  | const Glib::StringArrayHandle& | option_keys,
|  | const Glib::StringArrayHandle& | option_values
| ) |

void Gdk::Pixbuf::scale | ( | const Glib::RefPtr<Gdk::Pixbuf>& | dest,
|  | int | dest_x,
|  | int | dest_y,
|  | int | dest_width,
|  | int | dest_height,
|  | double | offset_x,
|  | double | offset_y,
|  | double | scale_x,
|  | double | scale_y,
|  | InterpType | interp_type
| ) | const

  | Creates a transformation of the source image src by scaling by scale_x and scale_y then translating by offset_x and offset_y , then renders the rectangle ( dest_x , dest_y , dest_width , dest_height ) of the resulting image onto the destination image replacing the previous contents. Try to use scale_simple() first, this function is the industrial-strength power tool you can fall back to if scale_simple() isn't powerful enough. Parameters:
  | dest | The Gdk::Pixbuf into which to render the results.
  | dest_x | The left coordinate for region to render.
  | dest_y | The top coordinate for region to render.
  | dest_width | The width of the region to render.
  | dest_height | The height of the region to render.
  | offset_x | The offset in the X direction (currently rounded to an integer).
  | offset_y | The offset in the Y direction (currently rounded to an integer).
  | scale_x | The scale factor in the X direction.
  | scale_y | The scale factor in the Y direction.
  | interp_type | The interpolation type for the transformation.

Glib::RefPtr<Gdk::Pixbuf> Gdk::Pixbuf::scale_simple | ( | int | dest_width,
|  | int | dest_height,
|  | InterpType | interp_type
| ) | const

  | Create a new Gdk::Pixbuf containing a copy of src scaled to dest_width x dest_height . Leaves src unaffected. interp_type should be Gdk::INTERP_NEAREST if you want maximum speed (but when scaling down Gdk::INTERP_NEAREST is usually unusably ugly). The default interp_type should be Gdk::INTERP_BILINEAR which offers reasonable quality and speed. You can scale a sub-portion of src by creating a sub-pixbuf pointing into src ; see new_subpixbuf(). For more complicated scaling/compositing see scale() and composite(). Parameters:
  | dest_width | The width of destination image.
  | dest_height | The height of destination image.
  | interp_type | The interpolation type for the transformation.
Returns: The new Gdk::Pixbuf, or `0` if not enough memory could be allocated for it.

## Friends And Related Function Documentation

Glib::RefPtr<Gdk::Pixbuf> wrap | ( | GdkPixbuf* | object,
|  | bool | take_copy = `false`
| ) | `[related]`

  | Parameters:
  | object | The C instance
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.
Returns: A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- pixbuf.h